<?php
/**
 * @package Tabaoca.Component.Tabapapo.Administrator
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

namespace Tabaoca\Component\Tabapapo\Administrator\Controller;

\defined('_JEXEC') or die;

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Response\JsonResponse;
use Joomla\CMS\Language\Text;

/**
 * Dashboard Controller of Tabapapo Chat component
 *
 * @package     Tabaoca.Component.Tabapapo.Administrator
 * @subpackage  com_tabapapo
 * @since       1.0.0
 */

class DashboardController extends BaseController {
    
    /**
	* Method to start the loop to refresh data.
	* 
	* @return  object  Response JSON encoded object to XHR call.
	* @since   1.0.0
	*/
	public function run () {

		try {

			if (!Session::checkToken('get')) {

				echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);

			} else {

				$input = Factory::getApplication()->input;

				$n_users_on = $input->get('n_users_on', 0, 'INT');
                $n_users = $input->get('n_users', 0, 'INT');
				$n_active_chats = $input->get('n_active_chats', 0, 'INT');
                $n_chats = $input->get('n_chats', 0, 'INT');
                $n_messages = $input->get('n_messages', 0, 'INT');

				$model = $this->getModel();

				$record = $model->run($n_users_on, $n_users, $n_active_chats, $n_chats, $n_messages);

				echo new JsonResponse($record);

			}

		} catch (Exception $e) {

			echo new JsonResponse($e);

		}

	}

}
