<?php
/**
 * @package Tabaoca.Component.Tabapapo.Administrator
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

\defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Component\ComponentHelper;

$app = Factory::getApplication();
$document = Factory::getDocument();
$session = $app->getSession();
$config = ComponentHelper::getParams('com_tabapapo');

$cb_integration = $config->get('cb_integration');

if ($cb_integration && !ComponentHelper::isEnabled('com_comprofiler')) {

	$app->enqueueMessage(Text::_('COM_TABAPAPO_CB_INTEGRATION_WARNING'), 'warning');

}

$wa = $document->getWebAssetManager();
$wa->useScript('keepalive');

Text::script('COM_TABAPAPO_TIMEOUT');

?>

<script language="JavaScript">

function addLoadEvent(func) {
	var oldonload = window.onload;
	if (typeof window.onload != 'function') {
			window.onload = func;
	} 
	else {
			window.onload = function() {
					if (oldonload) {
							oldonload();
					}
					func();
			}
		}
}

addLoadEvent(function(){setup_taba_admin();});

</script>

<div class="container">

	<div id="data_gabble" class="row">

		<div class="col-md-4">

			<div class="row">

				<div class="box_data box_users">
					<span class="title_data"><i class="icon-users"></i><b> <?php echo Text::_('COM_TABAPAPO_USERS_ON');?></b></span>
					<div class="field_data">
						<span id="users_on"></span><span id="users"></span>
					</div>
				</div>

				<div class="box_data box_chats">
					<span class="title_data"><i class="icon-comments-2"></i><b> <?php echo Text::_('COM_TABAPAPO_ACTIVE_CHATS');?></b></span>
					<div class="field_data">
						<span id="active_chats"></span><span id="chats"></span>
					</div>
				</div>

				<div class="box_data box_msgs">
					<span class="title_data"><i class="icon-comments"></i><b> <?php echo Text::_('COM_TABAPAPO_MESSAGES');?></b></span>
					<div class="field_data">
						<span id="messages"></span>
					</div>
				</div>

			</div>

		</div>

		<div class="col-md-4">

		</div>

	</div>

	<input type="hidden" id="uri_base" value="<?php echo Uri::base(); ?>">
	<input type="hidden" id="token" value="<?php echo $session->getFormToken(); ?>">

</div>

<p style="text-align:right;" ><?php echo Text::_('COM_TABAPAPO_POWERED');?> <a href="https://tabaoca.org">Tabaoca</a></p>
