<?php
/**
 * @package Tabaoca.Component.Tabapapo.Administrator
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

\defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Router\Route;

$app = Factory::getApplication();
$input = $app->input;

$this->ignore_fieldsets = ['item_associations', 'jmetadata'];
$this->useCoreUI = true;

$wa = $this->document->getWebAssetManager();
$wa->useScript('keepalive')
	->useScript('form.validate')
	->useScript('inlinehelp');

?>

<form action="<?php echo Route::_('index.php?option=com_tabapapo&view=tabapapo&layout=edit&id=' . (int) $this->item->id); ?>"
      method="post" 
      name="adminForm" 
      id="item-form" 
      aria-label="<?php echo Text::_('COM_TABAPAPO_FORM_TITLE_' . ((int) $this->item->id === 0 ? 'NEW' : 'EDIT'), true); ?>"
      class="form-validate">

	<?php echo LayoutHelper::render('joomla.edit.title_alias', $this); ?>   

	<div>
		<?php echo HTMLHelper::_('uitab.startTabSet', 'myTab', ['active' => 'details']); ?>

		<?php echo HTMLHelper::_('uitab.addTab', 'myTab', 'details', empty($this->item->id) ? Text::_('COM_TABAPAPO_TAB_NEW_MESSAGE') : Text::_('COM_TABAPAPO_TAB_EDIT_MESSAGE')); ?>

		<div class="row">
			<div class="col-md-9">
				<div class="row">
					<div class="col-md-6">
						<fieldset class="adminform">
								<legend><?php echo $this->form->getLabel('description'); ?></legend>
								<?php echo $this->form->getInput('description'); ?>
						</fieldset>
					</div>
				</div>
			</div>
			<div class="col-lg-3">
				<div class="card">
					<div class="card-body">
						<?php echo LayoutHelper::render('joomla.edit.global', $this); ?>
					</div>
				</div>
			</div>
		</div>

		<?php echo HTMLHelper::_('uitab.endTab'); ?>
		<?php echo HTMLHelper::_('uitab.addTab', 'myTab', 'params', Text::_('JGLOBAL_FIELDSET_DISPLAY_OPTIONS')); ?>
		
		<div class="row">
			<div class="col-md-6">
				<?php echo LayoutHelper::render('joomla.edit.params', $this); ?>
			</div>
		</div>
		
		<?php echo HTMLHelper::_('uitab.endTab'); ?>
		<?php echo HTMLHelper::_('uitab.addTab', 'myTab', 'publishing', Text::_('JGLOBAL_FIELDSET_PUBLISHING')); ?>
		
		<div class="row">
			<div class="col-md-6">
				<fieldset id="fieldset-publishingdata" class="options-form">
					<legend><?php echo Text::_('JGLOBAL_FIELDSET_PUBLISHING'); ?></legend>
					<div>
						<?php echo LayoutHelper::render('joomla.edit.publishingdata', $this); ?>
					</div>
				</fieldset>
			</div>
			<div class="col-md-6">
				<fieldset id="fieldset-metadata" class="options-form">
					<legend><?php echo Text::_('JGLOBAL_FIELDSET_METADATA_OPTIONS'); ?></legend>
					<div>
						<?php echo LayoutHelper::render('joomla.edit.metadata', $this); ?>
					</div>
				</fieldset>
			</div>
		</div>
		
		<?php echo HTMLHelper::_('uitab.endTab'); ?>

    	<?php echo HTMLHelper::_('uitab.endTabSet'); ?>
	
	</div>
    
	<input type="hidden" name="task" value="" />
    <?php echo HTMLHelper::_('form.token'); ?>

</form>
