/**
 * @package Tabaoca.Component.Tabapapo.Site
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

var content_table = '';
var content_pagination = '';
var uri_tabapapo;
var profile;
var tk;

var n_total_rooms = 0,
	rooms = '';

function setup_list () {
	
	tk = document.getElementById('jform_tk').value;
	uri_tabapapo = document.getElementById('uri_tabapapo').value;
	profile = document.getElementById('taba_profile').value;

	if (sessionStorage.getItem('jform_page_actual')) {

		document.getElementById('jform_page_actual').value = sessionStorage.getItem('jform_page_actual');
		document.getElementById('jform_list_limit').value = sessionStorage.getItem('jform_list_limit');
		document.getElementById('jform_my_filter').value = sessionStorage.getItem('jform_my_filter');
		document.getElementById('jform_search').value = sessionStorage.getItem('jform_search');
		document.getElementById('jform_list_filter').value = sessionStorage.getItem('jform_list_filter');
		document.getElementById('jform_list_asc').value = sessionStorage.getItem('jform_list_asc');
	}

	run_list();
	
}

function run_list() {

	var mydata = new FormData();
	var xhr = new XMLHttpRequest(); 
	
	var url = uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos&task=tabapapos.runlist&format=json&' + tk + '=1';

	mydata.append('page_actual', document.getElementById('jform_page_actual').value);
	mydata.append('list_limit', document.getElementById('jform_list_limit').value);
	mydata.append('my_filter', document.getElementById('jform_my_filter').value);
	mydata.append('search', document.getElementById('jform_search').value);
	mydata.append('filter', document.getElementById('jform_list_filter').value);
	mydata.append('direction', document.getElementById('jform_list_asc').value);
	mydata.append('n_total_rooms', n_total_rooms);
	mydata.append('rooms', rooms);

	xhr.open("POST", url, true);

	// function execute after request is successful 
	xhr.onreadystatechange = function () {
		
								if (this.readyState == 4 && this.status == 200) {
									
									Jxhr = JSON.parse(xhr.response);
									
									if (Jxhr.data[0] <= document.getElementById('jform_list_limit').value) {
										document.getElementById('jform_page_actual').value = 1;
									}
									
									list_rooms(Jxhr.data.rooms);
									pagination_chat(Jxhr.data.n_total_rooms);

									rooms = JSON.stringify(Jxhr.data.rooms);
									n_total_rooms = Jxhr.data.n_total_rooms;

									run_list();

								}
							}
								
	xhr.send(mydata);

}

function list_rooms(items) {
	
	var i;
	var params;
	var show_private;
	var show_dice;
	var users_limit;
	var avatar;
	var button_room;
	var button_edit;
	var table;
	var created_by;
	
	table = '<table class="listRoom">' +
			'<thead><tr><th>' + Joomla.JText._('COM_TABAPAPO_FIELD_TITLE_LABEL') + '<i class="arrow-down-3"></i>' +
			'</th><th>' + Joomla.JText._('COM_TABAPAPO_FIELD_CATEGORY_LABEL') + '<i class="arrow-down-3"></i>' +
			'</th><th>' + Joomla.JText._('COM_TABAPAPO_FIELD_OWNER_LABEL') + '<i class="arrow-down-3"></i>' +
			'</th><th>' + Joomla.JText._('COM_TABAPAPO_FIELD_PRIVATE_LABEL') +
			'</th><th>' + Joomla.JText._('COM_TABAPAPO_FIELD_DICE_LABEL') +
			'</th><th>' + Joomla.JText._('COM_TABAPAPO_FIELD_USERS_LIMIT_LABEL') +
			'</th></tr></thead><tbody>';

	if (items.length > 0) {
		
		for (i = 0; i < items.length; i++) {
				
			params = JSON.parse(items[i].params);
			users_limit = params.users_limit;
			
			if (params.users_limit == '') {
				
				users_limit = 10; 
				
			} else {
				
				users_limit = params.users_limit;
				
			}
			
			if (params.show_private == '0')  {
				
				show_private = '<span class="icon-unpublish taba-no" title="' + Joomla.JText._('COM_TABAPAPO_NO') + '"></span>';
				
			} else if (params.show_private == '1')  {
				
				show_private = '<span class="icon-publish taba-yes" title="' + Joomla.JText._('COM_TABAPAPO_YES') + '"></span>';
				
			}
			
			if (params.show_dice == '0')  {
				
				show_dice = '<span class="icon-unpublish taba-no" title="' + Joomla.JText._('COM_TABAPAPO_NO') + '"></span>';
				
			} else if (params.show_dice == '1')  {
				
				show_dice = '<span class="icon-publish taba-yes" title="' + Joomla.JText._('COM_TABAPAPO_YES') + '"></span>';
				
			}
			
			if (document.getElementById('jform_username').value == items[i].created_by) {
				
				button_edit = '<a class="btn btn-warning btn-sm" href="' + uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapo&layout=edit&id=' + items[i].id + '" role="button">' + '<i class="icon-edit" title="' + Joomla.JText._('COM_TABAPAPO_FIELD_EDIT_LABEL') + '"></i></a>';
				
			}
			else {
				
				button_edit = '';
				
			}
			
			button_room = '<a class="btn btn-success btn-sm" href="' + uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos&layout=tabapapo&id=' + items[i].id + '" role="button" title="' + items[i].created + '">' + items[i].title + '</a>';
			
			if (profile && items[i].avatar) {

				if (items[i].avatar.startsWith('gallery')) {

					avatar = uri_tabapapo + 'images/comprofiler/' + items[i].avatar;

				} else {

					avatar = uri_tabapapo + 'images/comprofiler/tn' + items[i].avatar;

				}

				created_by = `<a class="btn btn-secondary btn-sm" href="${uri_tabapapo}index.php/cb-profile/${items[i].created_by}">
								<img class="taba-avatar" src="${avatar}" alt="${items[i].created_by}" title="${items[i].created_by}" class="">
								<span>${items[i].created_by}</span></a>`;

			} else {
			
				created_by = '<span>' + items[i].created_by + '</span>';

			}

			table += '<tr><td>' + button_room + ' ' + button_edit + '</td>'+
					 '<td>' + items[i].category_title + '</td>' +
					 '<td>' + created_by + '</td>'+
					 '<td>' + show_private + '</td>' +
					 '<td>' + show_dice + '</td>' +
					 '<td>' + items[i].users_on + '/' + users_limit + '</td></tr>';
		}
	
	
		table += '</tbody></table>';
		
		if (content_table != table) {

			document.getElementById('showlist').innerHTML = table;
		
		}
		
		content_table = table;
		
	} else {
		
		document.getElementById('showlist').innerHTML = Joomla.JText._('COM_TABAPAPO_NOCHATS');
		content_table = '';
	}
}

function change_filter () {

		sessionStorage.setItem('jform_page_actual', document.getElementById('jform_page_actual').value);
		sessionStorage.setItem('jform_list_limit', document.getElementById('jform_list_limit').value);
		sessionStorage.setItem('jform_my_filter', document.getElementById('jform_my_filter').value);
		sessionStorage.setItem('jform_search', document.getElementById('jform_search').value);
		sessionStorage.setItem('jform_list_filter', document.getElementById('jform_list_filter').value);
		sessionStorage.setItem('jform_list_asc', document.getElementById('jform_list_asc').value);

		location.reload();

}


function pagination_chat(num_rows) {
	
	var html;
	var page_actual = document.getElementById('jform_page_actual').value;
	var list_limit = document.getElementById('jform_list_limit').value;
	var totalPage = Math.ceil(num_rows / list_limit);
	var i;
	var n;
	var x;
	var link;
	var nrows;
	
	if (num_rows == 1) {
		
		nrows = Joomla.JText._('COM_TABAPAPO_ONECHAT');
		
	} else {
		
		nrows = Joomla.JText._('COM_TABAPAPO_CHATS');
		
	}
	
	html = '<ul class="pagination"><li class="active page-item"><span class="page-link"><span>' + num_rows + ' ' + nrows + '</span></span></li></ul>';
	
	if (num_rows == 0) {
		
		html = '';
		
	}
	
	if (num_rows > list_limit) {
	
		html += '<ul class="pagination">';
	
		if(page_actual <= totalPage) {
		
			if (page_actual == 1) {
							
				html += '<li class="disabled page-item"><span class="page-link"><span class="icon-angle-double-left"></span></span></li>'+
						'<li class="disabled page-item"><span class="page-link"><span class="icon-angle-left"></span></span></li>';
				
			} else {
							
				
				
				n = page_actual - 1;
				
				html += '<li class="taba-hover page-item"><span onclick="change_page(1);" class="taba-hover page-link"><span class="icon-angle-double-left"></span></span></li>'+
						'<li class="taba-hover page-item"><span onclick="change_page(' + n + ');" class="taba-hover page-link"><span class="icon-angle-left"></span></span></li>';
				
			}
			
			
			for(i = 0; i < totalPage; i++){

				n = i + 1;
				
				if (n == page_actual) {
					
					html += '<li class="active page-item"><span class="taba-hover page-link">' + n + '</span></li>';
				
				} else {
					
					link = '<span onclick="change_page(' + n + ');" class="taba-hover page-link">' + n + '</span>';
					html += '<li class="page-item">' + link + '</li>';
					
				}
				
			}
			
			if (page_actual == totalPage) {
				
				html += '<li class="disabled page-item"><span class="taba-hover page-link"><span class="icon-angle-right"></span></span></li>'+
						'<li class="disabled page-item"><span class="taba-hover page-link"><span class="icon-angle-double-right"></span></span></li></ul>';
				
			} else {
				
				x = parseInt(page_actual, 10) + 1;
				html += '<li class="page-item"><span onclick="change_page(' + x + ');" class="taba-hover page-link"><span class="icon-angle-right"></span></span></li>'+
						'<li class="page-item"><span onclick="change_page(' + totalPage + ');" class="taba-hover page-link"><span class="icon-angle-double-right"></span></span></li></ul>';
				
				
			}

			
		
		}
		
		if (content_pagination != html) {
			
			document.getElementById("pagination").innerHTML = html;
			
		}
			
		content_pagination = html;	
	
	} else {
		
		document.getElementById("pagination").innerHTML = html;
		content_pagination = '';
	}
}

function change_page(page_n) {
	
	document.getElementById('jform_page_actual').value = page_n;
	change_filter();
	
}


