/**
 * @package Tabaoca.Administrator
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

var n_users = 0,
	n_users_on = 0,
	n_active_chats = 0,
	n_chats = 0,
	n_messages = 0;

var uri_base;
var tk;

function setup_taba_admin () {

	uri_base = document.getElementById('uri_base').value;
	tk = document.getElementById('token').value;

	run_taba_admin();

}

function run_taba_admin () {

	var myForm = new FormData();
	var xhr = new XMLHttpRequest(); 
	var url = uri_base + 'index.php?option=com_tabapapo&view=dashboard&task=dashboard.run&format=json&' + tk + '=1';

	myForm.append('n_users', n_users);
	myForm.append('n_users_on', n_users_on);
	myForm.append('n_chats', n_chats);
	myForm.append('n_active_chats', n_active_chats);
	myForm.append('n_messages', n_messages);

	xhr.open("POST", url, true);

	xhr.onreadystatechange = function () {

								if (this.readyState == 4 && this.status == 200) {

									Jxhr = JSON.parse(xhr.response);

									if (Jxhr.data !== null) {

										if (Jxhr.data.users_on !== null) {

											document.getElementById('users_on').innerHTML = Jxhr.data.users_on;
											n_users_on = Jxhr.data.users_on;

										} else {

											document.getElementById('users_on').innerHTML = n_users_on;

										}

										if (Jxhr.data.users !== null) {

											document.getElementById('users').innerHTML = ' / ' + Jxhr.data.users;
											n_users = Jxhr.data.users;

										}

										if (Jxhr.data.chats !== null) {

											document.getElementById('chats').innerHTML = ' / ' + Jxhr.data.chats;
											n_chats = Jxhr.data.chats;

										}

										if (Jxhr.data.active_chats !== null) {

											document.getElementById('active_chats').innerHTML = Jxhr.data.active_chats;
											n_active_chats = Jxhr.data.active_chats;

										} else {

											document.getElementById('active_chats').innerHTML = n_active_chats;

										}

										if (Jxhr.data.messages !== null) {

											document.getElementById('messages').innerHTML = Jxhr.data.messages;
											n_messages = Jxhr.data.messages;

										}

										setTimeout(function () { run_taba_admin();}, 0);

									} else {

										alert(Joomla.JText._('COM_TABAPAPO_TIMEOUT'));
										location.reload();

									}

								}

							}

	xhr.send(myForm);

}
