/**
 * @package Tabaoca.Component.Tabapapo.Site
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

var n_users_chat = 0,
	n_users_on = 0,
	room_lmsg_id = 0,
	uri_tabapapo,
	user_tabapapo,
	profile,
	tk;

function setup_tabapapo() {

	uri_tabapapo = document.getElementById('uri_tabapapo').value;
	user_tabapapo = parseInt(document.getElementById('jform_usu_id').value);
	profile = document.getElementById('taba_profile').value;
	tk = document.getElementById('jform_tk').value;

	roll_frame();
	verify_msg();
	
	if (document.getElementById('jform_description').value != '') {
		
		document.getElementById('divdesc').hidden = false;
		
	}
	
	document.getElementById('jform_status').addEventListener('click', function () {refresh_status();document.getElementById('jform_msg').focus();});
	document.getElementById('jform_privado').addEventListener('click', function () {document.getElementById('jform_msg').focus();});
	document.getElementById('jform_roll_frame').addEventListener('change', function () {document.getElementById('jform_msg').focus();});
	document.getElementById('showmsg').addEventListener('mousemove', function () {document.getElementById('jform_roll_frame').checked = false;});
	document.getElementById('showmsg').addEventListener('mouseleave', function () {document.getElementById('jform_roll_frame').checked = true; roll_frame()});

	document.getElementById('jform_msg').addEventListener('keyup', function () {verify_msg();});
	document.getElementById('jform_msg').addEventListener('keydown', function () {verify_msg();});
	document.getElementById('jform_msg').addEventListener('keypress', function () {verify_msg(); if (event.keyCode==13){ event.preventDefault(); send_msg();}});
	document.getElementById('jform_msg').focus();
	
	if (document.getElementById('jform_talkto_id').value == 0){
	
		document.getElementById('cb_private').hidden = true;
		system_frase(document.getElementById('jform_talkto_name').value);
		
	} else {
		
		document.getElementById('cb_private').removeAttribute('hidden');
		system_frase(document.getElementById('jform_talkto_name').value);
		
	}
	
	enter_room();

}

function enter_room() {

	var mydata = new FormData();
	var xhr = new XMLHttpRequest(); 
	var url = uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos&task=tabapapos.enterRoom&format=json&' + tk + '=1';

	mydata.append('sala_id', document.getElementById('jform_sala_id').value);
	mydata.append('room_lmsg_id', room_lmsg_id);
	mydata.append('n_users_chat', n_users_chat);
	mydata.append('n_users_on', n_users_on);

	xhr.open("POST", url, true);

	xhr.onreadystatechange = function () {

								if (this.readyState == 4 && this.status == 200) {

									Jxhr = JSON.parse(xhr.response);

									populateUsersOn(Jxhr.data.users, document.getElementById('jform_users_limit').value);
									populateChatRoom(Jxhr.data.msgs);
									document.getElementById('showmsg').scrollTo(0, document.getElementById('showmsg').scrollHeight);
									n_users_chat = Jxhr.data.n_users;
									n_users_on = Jxhr.data.n_users_on;
									run_tabapapo();

								}

							};

	xhr.send(mydata);
	
}

function run_tabapapo() {

	var mydata = new FormData();
	var xhr = new XMLHttpRequest(); 
	var url = uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos&task=tabapapos.run&format=json&' + tk + '=1';
	
	mydata.append('sala_id', document.getElementById('jform_sala_id').value);
	mydata.append('room_lmsg_id', room_lmsg_id);
	mydata.append('n_users_chat', n_users_chat);
	mydata.append('n_users_on', n_users_on);

	xhr.open("POST", url, true);

	xhr.onreadystatechange = function () {

								if (this.readyState == 4 && this.status == 200) {

									Jxhr = JSON.parse(xhr.response);

									if (Jxhr.data !== null) {
									
										populateUsersOn(Jxhr.data.users, document.getElementById('jform_users_limit').value);
										populateChatRoom(Jxhr.data.msgs);
										
										n_users_chat = Jxhr.data.n_users;
										n_users_on = Jxhr.data.n_users_on;

										run_tabapapo();

									} else {

										alert(Joomla.JText._('COM_TABAPAPO_TIMEOUT'));
										location.reload();

									}

								}

							};

	xhr.send(mydata);
	
}

function populateChatRoom(msgs) { 

	var i;
	var type;
	var textmsg;
	var username;
	var talktoname;
	var params;
	var paramsjson;
	var tempo;
	var print_msgs = '';
	var avatar;
	var avatar_talkto;

	if (msgs.length > 0) { 
		
		for (i = 0; i < msgs.length; i++) {
			
			tempo = msgs[i].tempo;
			
			room_lmsg_id = msgs[i].id;
			
			params = msgs[i].params;
			paramsjson = JSON.parse(params);
			username = paramsjson.usu_name;
			talktoname = paramsjson.talkto_name;
			textmsg = msgs[i].msg;			

			if (msgs[i].usu_id == 0) {

				type = 'taba-chat-msgsystem';

				print_msgs += '<div class="' + type + '"><div><spam class="taba-chat-msghead">' + ' ' + '<i = class="icon-chevron-right taba-icon" title="' + 'System Message: ' + tempo + '"></i></spam></div>' + '<div class="taba-chat-msg">' + textmsg + '</div></div>';

			} else {

				if (profile) {
				
					if (msgs[i].avatar) {

						if (msgs[i].avatar.startsWith('gallery')) {

							avatar = '<img class="taba-avatar" src="' + uri_tabapapo + 'images/comprofiler/' + msgs[i].avatar + '" title="' + username + '">';

						} else {

							avatar = '<img class="taba-avatar" src="' + uri_tabapapo + 'images/comprofiler/tn' + msgs[i].avatar + '" title="' + username + '">';

						}
		
					} else {

						avatar = '<i class="icon-user taba-no-avatar"></i><span>' + username + '</span>';

					}

					if (msgs[i].avatar_talkto) {

						if (msgs[i].avatar_talkto.startsWith('gallery')) {

							avatar_talkto = '<img class="taba-avatar" src="' + uri_tabapapo + 'images/comprofiler/' + msgs[i].avatar_talkto + '" title="' + talktoname + '">';

						} else {

							avatar_talkto = '<img class="taba-avatar" src="' + uri_tabapapo + 'images/comprofiler/tn' + msgs[i].avatar_talkto + '" title="' + talktoname + '">';

						}
		
					} else {

						avatar_talkto = '<i class="icon-user taba-no-avatar"></i><span>' + talktoname + '</span>';

					}

				} else {

					avatar = '<i class="icon-user taba-no-avatar"></i>';
					avatar_talkto = '<i class="icon-user taba-no-avatar"></i>';

				}

				if (msgs[i].falacom_id == 0) {
				
					if (msgs[i].reservado == 0) {
				
						if (msgs[i].usu_id == user_tabapapo) {

							type = 'taba-chat-self';

						} else {

							type = 'taba-chat-others';

						}
						
					}

					print_msgs += '<div class="' + type + '"><div><spam class="taba-chat-msghead" title="' + tempo + '">' + avatar + '<b>' + username + '</b> </spam></div>' + '<div class="taba-chat-msg">' + textmsg + '</div></div>';

				} else {
					
					if (msgs[i].reservado == 0) {

						type = 'taba-chat-direct';
							
						print_msgs += '<div class="' + type + '"><div><spam class="taba-chat-msghead" title="' + tempo + '">' + avatar + '<b>' + username + ' ' + '<i class="icon-arrow-right-4 taba-icon"></i>' + ' ' + avatar_talkto + talktoname + '</b> </spam></div>' + '<div class="taba-chat-msg">&nbsp;' + textmsg + '</div></div>';
							
					} else {
					
						if ((msgs[i].usu_id == user_tabapapo) || (msgs[i].falacom_id == user_tabapapo)) {

							type = 'taba-chat-direct-private';

							print_msgs += '<div class="' + type + '"><div><spam class="taba-chat-msghead" title="' + tempo + '">' + '<i class="taba-private icon-unpublish taba-icon" title="' + 'Private Message' + '"></i>' + avatar + '<b>' + username + ' ' + '<i class="icon-arrow-right-4 taba-icon"></i>' + ' ' + avatar_talkto + talktoname + '</b> </spam></div>' + '<div class="taba-chat-msg">' + textmsg + '</div></div>';

						} 

					}
					
				}
				
			}

		}
		
		document.getElementById('showmsg').innerHTML += print_msgs; 
	
	}

}

function populateUsersOn(userson, users_limit) { 

	var print_users;
	var old_users;
	var i;
	var owner;
	var params;
	var paramsjson;
	var username;
	var user;
	var tempo;
	var avatar;
	var avatar_user;

	print_users = '<div class="taba-chat-allusers taba-hover" onclick="select_talkto(0,' + "''" + ');"><i class="icon-users"></i>' + ' ' + '<b>' + Joomla.JText._('COM_TABAPAPO_USERSON_ALLUSERS') + ' [ ' + userson.length + '/' + users_limit + ' ]</b></div>';

	old_users = document.getElementById('showusers').innerHTML;

	if (userson.length > 0) { 
		
		for (i = 0; i < userson.length; i++) {
						
			owner = '';
			params = userson[i].params;
			paramsjson = JSON.parse(params);
			username = paramsjson.usu_name;
			avatar_user = paramsjson.avatar;
			tempo = paramsjson.getin_time;

			if (userson[i].usu_id != user_tabapapo) {
			
				if (profile && avatar_user) {

					if (avatar_user.startsWith('gallery')) {

						avatar = '<img class="taba-avatar" src="' + uri_tabapapo + 'images/comprofiler/' + avatar_user + '" title="' + tempo + '">';

					} else {

						avatar = '<img class="taba-avatar" src="' + uri_tabapapo + 'images/comprofiler/tn' + avatar_user + '" title="' + tempo + '">';

					}

					user = '<a href="' + uri_tabapapo + 'index.php/cb-profile/' + username + '" target="_blank">' + avatar + '<span>' + username + '</span></a>';

				} else {

					user = '<i class="icon-user taba-no-avatar"></i><span>' + username + '</span>';

				}

				if (userson[i].status == 0) { cla = 'taba-chat-away'; }
				
				if (userson[i].status == 1) { cla = 'taba-chat-conected'; }
				
				if (document.getElementById('jform_owner').value == userson[i].usu_id) { 
					
					owner = '<i class="icon-key" title="' + Joomla.JText._('COM_TABAPAPO_USERSON_OWNER') + '"></i>';
				
				}
				
				print_users += '<div class="taba-chat-username ' + cla + '" onclick="select_talkto(' + "'" + userson[i].usu_id + "'" + ',' + "'" + username + "'" + ');">' + user + ' ' + owner +'</div>';
			
			}

		}
				
		if (old_users != print_users){
			
			document.getElementById('showusers').innerHTML = print_users;
			
		}

	}

}

function send_msg(){

	if (document.getElementById('jform_privado').checked) {

		document.getElementById('jform_privado').value = 1;

	} else {

		document.getElementById('jform_privado').value = 0;

	}
	
	var myform = new FormData(document.getElementById("tabapapo_form"));
	var xhr = new XMLHttpRequest();
	var msg;
	var espacos;
	var url = uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos&task=tabapapos.sendMessage&format=json&' + tk + '=1';

	msg = document.getElementById('jform_msg').value;
	espacos = msg.split(' ');

	if(espacos.length - 1 == msg.length) {
	
		clear_msgbox();

	} else {

		xhr.open("POST", url, true);

		xhr.onreadystatechange = function () {
	
									if (this.readyState == 4 && this.status == 200) {
	
										Jxhr = JSON.parse(xhr.response);
	
										if (Jxhr.data.error) {

											select_talkto(0, '');
											document.getElementById('frase_sys').innerHTML = Jxhr.data.error;
											document.getElementById('jform_talkto_id').value = 0;
											document.getElementById('jform_talkto_name').value = '';
											setTimeout('system_frase("")',4000);

										}
										
										if (document.getElementById('jform_status').checked) {

											document.getElementById('jform_status').checked = false;

											refresh_status();

										}
										
										clear_msgbox();
										verify_msg();
	
									}
	
								};
	
		xhr.send(myform);
		
	}

}

function refresh_status () {
	
	var mydata = new FormData();
	var xhr = new XMLHttpRequest(); 
	
	var url = uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos&task=tabapapos.userstatus&format=json&' + tk + '=1';
	
	mydata.append('sala_id', document.getElementById('jform_sala_id').value);
	
	if (document.getElementById('jform_status').checked) {
		
		mydata.append('status', 0);
		
	}
	else {
		
		mydata.append('status', 1);
		
	}

	xhr.open("POST", url, true);

	xhr.onreadystatechange = function () {

								if (this.readyState == 4 && this.status == 200) {

									//Jxhr = JSON.parse(xhr.response);

									if (document.getElementById('jform_status').checked) {

										document.getElementById("statusb").className = "taba-status-away taba-status-chat";
												
		
									} else {
										
										document.getElementById("statusb").className = "taba-status-on taba-status-chat";
										
									}

								}

							};

	xhr.send(mydata);

}

function roll_dice(dice) {
	
	var mydata = new FormData();
	var xhr = new XMLHttpRequest();
	
	var url = uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos&task=tabapapos.rolldice&format=json&' + tk + '=1';
	
	mydata.append('sala_id', document.getElementById('jform_sala_id').value);
	mydata.append('dice', dice);

	xhr.open("POST", url, true);

	xhr.onreadystatechange = function () {

								if (this.readyState == 4 && this.status == 200) {

									//Jxhr = JSON.parse(xhr.response);

									document.getElementById('divdice').hidden = true;
									document.getElementById('jform_msg').focus();

								}

							};

	xhr.send(mydata);

}

function roll_frame() { 

		if (document.getElementById("jform_roll_frame").checked == true) {

			document.getElementById("showmsg").scrollBy({top: 70, left: 0, behavior: "smooth"});
			setTimeout("roll_frame();", 50); 

		}

}

function verify_msg() {

	var textar = document.getElementById('jform_msg');
	
	if (textar.value != '') {
		
		document.getElementById("botenviar").innerHTML = '<i class="icon-ok taba-hover taba-send" title="' + Joomla.JText._('COM_TABAPAPO_SEND') + '" style="color:#faa63f;" onClick="send_msg();"></i>';
		
	}

	else {

		document.getElementById("botenviar").innerHTML = '<i class="icon-ok taba-send" title="' + Joomla.JText._('COM_TABAPAPO_SEND') + '"></i>';

	}

	if (textar.value.lenght > 512) {

	    textar.value = textar.value.substr(0,511)

	}

}

function clear_msgbox() {

	document.getElementById('jform_msg').value = '';
	document.getElementById('jform_msg').focus();

}

function exit_room() {

	var mydata = new FormData();
	var xhr = new XMLHttpRequest();
	var url = uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos&task=tabapapos.exitroom&format=json&' + tk + '=1';
	 
	mydata.append('sala_id', document.getElementById('jform_sala_id').value);

	xhr.open("POST", url, true);

	xhr.onreadystatechange = function () {

								if (this.readyState == 4 && this.status == 200) {

									//Jxhr = JSON.parse(xhr.response);
									location.replace(uri_tabapapo + 'index.php?option=com_tabapapo&view=tabapapos');
								}

							};

	xhr.send(mydata);

}

function select_talkto(talkto_id, usu_name) {

	document.getElementById('jform_talkto_id').value = talkto_id;
	document.getElementById('jform_talkto_name').value = usu_name;
	
	
	if (talkto_id == '0') {
	
		document.getElementById('cb_private').hidden = true;
		document.getElementById('jform_privado').checked = false;
		document.getElementById('jform_privado').value = 0;
		system_frase(usu_name);
		
	} else {
		
		if (talkto_id != user_tabapapo) {
			
			if (document.getElementById('jform_show_private').value == '1') {

				document.getElementById('cb_private').removeAttribute('hidden');

			}
			
			system_frase(usu_name);
			
		} else {
			
			document.getElementById('jform_show_private').value == '0';
			document.getElementById('cb_private').hidden = true;
			document.getElementById('jform_privado').checked = false;
			document.getElementById('jform_privado').value = 0;
			document.getElementById('jform_talkto_id').value = 0;
			system_frase('');
		}

	}
	
	document.getElementById('jform_msg').focus();

}

function system_frase(usu_name) {

	if (usu_name == '') {
	
		usu_name = Joomla.JText._('COM_TABAPAPO_TABAPAPOCHAT_EVERYBODY');
	
	}
	
	document.getElementById('frase_sys').innerHTML = '<span>' + Joomla.JText._('COM_TABAPAPO_TABAPAPOCHAT_TALKINGTO') + ' ' + '<b>' + usu_name + '.</b></span>';

}


function show_info(type) {

	if (document.getElementById(type).hidden == true) {
		
		document.getElementById(type).hidden = false;
		
	}
	else {
		
		document.getElementById(type).hidden = true;
	
	}

	document.getElementById('jform_msg').focus();
	
}

function insert_emoji_chat(text) {
    
    var el = document.getElementById('jform_msg');
    var val = el.value, endIndex, range;
    
    if (typeof el.selectionStart != "undefined" && typeof el.selectionEnd != "undefined") {
        
		endIndex = el.selectionEnd;
        el.value = val.slice(0, el.selectionStart) + text + val.slice(endIndex);
        el.selectionStart = el.selectionEnd = endIndex + text.length;

    } else if (typeof document.selection != "undefined" && typeof document.selection.createRange != "undefined") {
        
		el.focus();
        range = document.selection.createRange();
        range.collapse(false);
        range.text = text;
        range.select();

    }

	verify_msg();
    document.getElementById('jform_msg').focus();
    
}
