<?php
/**
 * @package Tabaoca.Component.Tabapapo.Site
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

namespace Tabaoca\Component\Tabapapo\Site\Controller;

\defined('_JEXEC') or die('Restricted access');

use stdClass;
use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Response\JsonResponse;
use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Form\Form;

class TabapaposController extends BaseController {

	public function run() {
      
		if (!Session::checkToken('get')) {
            
            echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);
        
		} else {

            //parent::Display();

            $input = Factory::getApplication()->input;
       		//$form = $input->post->get('jform', array(), 'array');               
            $model = $this->getModel();
            //$item = $model->getitem();
            //$sala_id = $item->id;
            $sala_id = $input->get('sala_id', 0, 'INT');
			$n_users_chat = $input->get('n_users_chat', 0, 'INT');
			$n_users_on = $input->get('n_users_on', 0, 'INT');
            $room_lmsg_id = $input->get('room_lmsg_id', 0, 'INT');
            
      		if ($sala_id)
      		{
      			$record = $model->run($sala_id, $n_users_chat, $n_users_on, $room_lmsg_id);
      			if ($record) 
      			{
      				echo new JsonResponse($record);
      			}
      			else
      			{
      				echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_RECORDS'), true);
      			}
      		}
      		else 
      		{
      			$record = array();
      			echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_CHAT_BOUNDS'), true);
      		}

            
        }
   }


   public function enterRoom() {
      
		if (!Session::checkToken('get')) {
			
			echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);
		
		} else {

			//parent::Display();

			$input = Factory::getApplication()->input;
			//$form = $input->post->get('jform', array(), 'array');               
			$model = $this->getModel();
			//$item = $model->getitem();
			//$sala_id = $item->id;
			$sala_id = $input->get('sala_id', 0, 'INT');
			$n_users_chat = $input->get('n_users_chat', 0, 'INT');
			$n_users_on = $input->get('n_users_on', 0, 'INT');
			$room_lmsg_id = $input->get('room_lmsg_id', 0, 'INT');
			
			if ($sala_id)
			{
				$record = $model->enterRoom($sala_id, $n_users_chat, $n_users_on, $room_lmsg_id);
				
				if ($record) {
					
					echo new JsonResponse($record);

				} else	{
					
					echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_RECORDS'), true);

				}
			}
			else 
			{
				$record = array();
				echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_CHAT_BOUNDS'), true);
			}

			
		}
	}

   public function loadRoom() {
    
	if (!Session::checkToken('get')) 
	{
		echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);
	}
	else 
	{
		
		$input = Factory::getApplication()->input;

		$model = $this->getModel();

		$sala_id = $input->get('sala_id', 0, 'int');
		$room_lmsg_id = $input->get('room_lmsg_id', 0, 'int');

		  if ($sala_id)
		  {
			  $records = $model->roomLoad($sala_id, $room_lmsg_id);
		   
			  if ($records) 
			  {
				  echo new JsonResponse($records);
			  }
			  else
			  {
				  echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_RECORDS'), true);
			  }
		  }
		  else 
		  {
			  $records = array();
			  echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_CHAT_BOUNDS'), true);
		  }

	}
	}


   public function runList() {
	   
	   if (!Session::checkToken('get')) 
        {
            echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);
        }
        else 
        {

            $input = Factory::getApplication()->input;
              
            $model = $this->getModel();
            $page_actual = $input->get('page_actual', 0, 'INT');
            $my_filter = $input->get('my_filter', 0, 'INT');
            $list_limit = $input->get('list_limit', 0, 'INT');
            $filter = $input->get('filter', 0, 'INT');
            $search = $input->get('search', '', 'STRING');
            $direction = $input->get('direction', 0, 'INT');
			$n_total_rooms = $input->get('n_total_rooms', 0, 'INT');
			$rooms = $input->get('rooms', '', 'STRING');
            
      		if ($page_actual)
      		{
      			$record = $model->runList($page_actual, $my_filter, $list_limit, $filter, $search, $direction, $n_total_rooms, $rooms);
      			if ($record) 
      			{
      				echo new JsonResponse($record);
      			}
      			else
      			{
      				echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_RECORDS'), true);
      			}
      		}
      		else 
      		{
      			$record = array();
      			echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_CHAT_BOUNDS'), true);
      		}
            
        }
	   
	}


    public function sendMessage() {
    
        if (!Session::checkToken('get')) 
        {
            echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);
        }
        else 
        {

            //parent::display();
            
                   
            $input = Factory::getApplication()->input;
       		$form = $input->post->get('jform', array(), 'array');
       		$model = $this->getModel();

       		if ($form) {

       			$records = $model->messageSend($form);

       			if ($records) 
       			{
       				echo new JsonResponse($records);
       			}
       			else
       			{
       				echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_RECORDS'), true);
       			}

       		} else {

       			$records = array();
       			echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_CHAT_BOUNDS'), true);
				
       		}
      
        }
    }


    public function userstatus() {
    
        if (!Session::checkToken('get')) 
        {
            echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);
        }
        else 
        {

            //parent::getuserstatus();
            
            $input = Factory::getApplication()->input;
       		//$form = $input->post->get('jform', array(), 'array');                   
            $model = $this->getModel();
            //$item = $model->getitem();
            $sala_id = $input->get('sala_id', 0, 'INT');
            $status = $input->get('status', 0, 'INT');
                         
       		if ($sala_id)
       		{
       			$records = $model->statususer($sala_id, $status);
                
       			if ($records) 
       			{
       				echo new JsonResponse($records);
       			}
       			else
       			{
       				echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_RECORDS'), true);
       			}
       		}
       		else 
       		{
       			$records = array();
       			echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_CHAT_BOUNDS'), true);
       		}

        }
    }


    public function rolldice() {
    
        if (!Session::checkToken('get')) 
        {
            echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);
        }
        else 
        {

            //parent::getuserstatus();
            
            $input = Factory::getApplication()->input;
       		//$form = $input->post->get('jform', array(), 'array');                   
            $model = $this->getModel();
            //$item = $model->getitem();
            $sala_id = $input->get('sala_id', 0, 'INT');
            $dice = $input->get('dice', 0, 'INT');
                         
       		if ($sala_id)
       		{
       			$records = $model->diceroll($sala_id, $dice);
                
       			if ($records) 
       			{
       				echo new JsonResponse($records);
       			}
       			else
       			{
       				echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_RECORDS'), true);
       			}
       		}
       		else 
       		{
       			$records = array();
       			echo new JsonResponse(null, Text::_('COM_TABAPAPO_ERROR_NO_CHAT_BOUNDS'), true);
       		}

        }
    }


   public function exitRoom() {
      
      if (!Session::checkToken('get')) 
        {
            echo new JsonResponse(null, Text::_('JINVALID_TOKEN'), true);
        }
        else 
        {

            //parent::getoutDisplay();

            $input = Factory::getApplication()->input;
       		//$form = $input->post->get('jform', array(), 'array');             
            $model = $this->getModel();
            //$item = $model->getitem();
            $sala_id = $input->get('sala_id', 0, 'INT');
            
      		if ($sala_id)
      		{
      			$record = $model->roomExit($sala_id);
      			if ($record == $sala_id) 
      			{
					echo new JsonResponse($record);
      			}
      			else
      			{
      				echo new JsonResponse(null, JText::_('COM_TABAPAPO_ERROR_NO_RECORDS'), true);
      			}
      		}
      		else 
      		{
      			$record = array();
      			echo new JsonResponse(null, JText::_('COM_TABAPAPO_ERROR_NO_CHAT_BOUNDS'), true);
      		}

        }

   }

	/* Method to integration with Community Builder Component. */

	public function cb_display () {

		$lang = Factory::getLanguage();
		$lang->load('com_tabapapo', JPATH_SITE);
				
		$this->addViewPath(JPATH_SITE . '/components/com_tabapapo/views/');
		$this->addModelPath(JPATH_SITE . '/components/com_tabapapo/models/','tabapapoModel');
		
		$view = $this->getView('tabapapo', 'html');
		$view->addTemplatePath(JPATH_SITE . '/components/com_tabapapo/views/tabapapo/tmpl/');
		
		$model = $this->getModel('tabapapo', 'tabapapoModel');
		
		Form::addFormPath(JPATH_SITE . '/components/com_tabapapo/models/forms/');
		
		$view->setModel($model, true);
		
		$view->display();
		
	}

}
