<?php
/**
 * @package Tabaoca.Component.Tabapapo.Site
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

namespace Tabaoca\Component\Tabapapo\Site\View\Tabapapo;

\defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Helper\ContentHelper;
use Joomla\CMS\Language\Associations;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Toolbar\Toolbar;


class HtmlView extends BaseHtmlView {

	protected $form;
	protected $item;
    protected $state;
	protected $canDo;

	/**
	 * Display the Hello World view
	 *
	 * @param   string  $tpl  The name of the template file to parse; automatically searches through the template paths.
	 *
	 * @return  void
	 */
	public function display($tpl = null)
	{
		// Get the Data
		$this->form = $this->get('Form');
		$this->item = $this->get('Item');
		$this->state = $this->get('State');

		// What Access Permissions does this user have? What can (s)he do?
		$this->canDo = ContentHelper::getActions('com_tabapapo', 'tabapapo', $this->item->id);

		if ($this->canDo->get('core.create'))
		{

			// Display the template
			parent::display($tpl);

			// Set the document
			$this->setDocument(null);

		} 
		
		else {
				
			$app = Factory::getApplication(); 
			$app->enqueueMessage(Text::_('JERROR_ALERTNOAUTHOR'), 'error');

			return;
			
		}
	}


	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	public function setDocument($doc): void {

		$document = Factory::getDocument();

		$document->addStyleSheet('media/com_tabapapo/css/tabapapo.css');

	}
}
