<?php
/**
 * @package Tabaoca.Component.Tabapapo.Site
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

namespace Tabaoca\Component\Tabapapo\Site\View\Tabapapos;

\defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;
use Joomla\CMS\Date\Date;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Session\Session;

class HtmlView extends BaseHtmlView {
	/**
	 * Display the Tabapapo view
	 *
	 * @param   string  $tpl  The name of the template file to parse; automatically searches through the template paths.
	 *
	 * @return  void
	 */
	public function display($tpl = null) {
      
		  // Assign data to the view
			$this->item = $this->get('Item');
			
			$this->options = $this->get('Options');
		  
			//$this->table = $this->get('Table');
			
			if (!$this->form = $this->get('Form'))
			{
				echo "Can't load form.<br>";
				return;
			}
		     
      //$this->script = $this->get('Script');

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JLog::add(implode('<br />', $errors), JLog::WARNING, 'jerror');

			return false;
		}
     
		$tmpl = BaseHtmlView::getLayout();
		$this->setDocument($tmpl);
      
      // Display the view
		parent::display($tpl);

	
	}
	

	public function setDocument($tmpl): void {
		$document = Factory::getDocument();
		
		switch ($tmpl) {

			case "default":
				$document->setTitle(Text::_('COM_TABAPAPO_TABAPAPO_CHAT'));
				$document->addScript('media/com_tabapapo/js/tabapapo.js' . '?' .Session::getFormToken());
				$document->addStyleSheet('media/com_tabapapo/css/tabapapo.css' . '?' .Session::getFormToken());

				break;

			case "tabapapo":
				$document->setTitle(Text::_('COM_TABAPAPO_TABAPAPO_CHAT'));
				$document->addScript('media/com_tabapapo/js/tabapapo_chat.js' . '?' .Session::getFormToken());
				$document->addStyleSheet('media/com_tabapapo/css/tabapapo.css' . '?' .Session::getFormToken());
				Text::script('COM_TABAPAPO_TIMEOUT');
				
				break;
		}
		
		Text::script('COM_TABAPAPO_MESSAGES_TO');
		Text::script('COM_TABAPAPO_USERSON_ALLUSERS');
		Text::script('COM_TABAPAPO_USERSON_OWNER');
		Text::script('COM_TABAPAPO_TABAPAPOCHAT_TALKINGTO');
		Text::script('COM_TABAPAPO_TABAPAPOCHAT_EVERYBODY');
		Text::script('COM_TABAPAPO_FIELD_TITLE_LABEL');
		Text::script('COM_TABAPAPO_FIELD_CATEGORY_LABEL');
		Text::script('COM_TABAPAPO_FIELD_OWNER_LABEL');
		Text::script('COM_TABAPAPO_FIELD_EDIT_LABEL');
		Text::script('COM_TABAPAPO_FIELD_PRIVATE_LABEL');
		Text::script('COM_TABAPAPO_FIELD_DICE_LABEL');
		Text::script('COM_TABAPAPO_FIELD_USERS_LIMIT_LABEL');
		Text::script('COM_TABAPAPO_YES');
		Text::script('COM_TABAPAPO_NO');
		Text::script('JGLOBAL_USE_GLOBAL');
		Text::script('COM_TABAPAPO_SEND');
		Text::script('COM_TABAPAPO_NOCHATS');
		Text::script('COM_TABAPAPO_ONECHAT');
		Text::script('COM_TABAPAPO_CHATS');
      
	}
	
}
