<?php
/**
 * @package Tabaoca.Component.Tabapapo.Site
 * @subpackage com_tabapapo
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

\defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Component\ComponentHelper;

$currentuser = Factory::getuser();
$document = Factory::getDocument();
$app = Factory::getApplication();

$wa = $document->getWebAssetManager();
$wa->useScript('keepalive');

$config = $app->getParams('com_tabapapo');
$cb_integration = $config->get('cb_integration');

if ($cb_integration && ComponentHelper::isEnabled('com_comprofiler')) {

	$profile = true;

} else {

	$profile = false;

}

if ( !$currentuser->get("id")){

   $app->enqueueMessage(Text::_('JERROR_ALERTNOAUTHOR'), 'error');
   $app->setHeader('status', 403, true);
   return;

}

?>

<script language="JavaScript">

	function addLoadEvent(func) {
		var oldonload = window.onload;
		if (typeof window.onload != 'function') {
				window.onload = func;
		} 
		else {
				window.onload = function() {
						if (oldonload) {
								oldonload();
						}
						func();
				}
			}
	}

	addLoadEvent(function(){setup_list();});

</script>

<form action="#" method="post" id="listForm" name="listForm">

<div class="container taba-bg">
	<div class="taba-menu">
		<div class="row">
			<div class="col-md-6">
				<a class="btn btn-success" href="<?php echo Uri::root().'index.php?option=com_tabapapo&view=tabapapo&layout=edit'; ?>" role="button"><i class="icon-new"></i><?php echo ' '.Text::_('COM_TABAPAPO_ADD_CHAT_ROOM');?></a>
			</div>			
			<div class="col-md-6">
				<div class="input-group">
					<input type="text" name="jform[search]" id="jform_search" value="" class="form-control" placeholder="Search" onkeypress="if (event.keyCode == 13) {event.preventDefault();change_filter();}">
					<button type="button" class="filter-search-bar__button btn btn-primary" onclick="change_filter();"><i class="filter-search-bar__button icon-search"></i></button>
				</div>
			</div>
		</div>
	</div>
	<div class="taba-filter">
		<div class="row">
			<div class="col-md-4">
				<select id="jform_my_filter" name="jform[my_filter]" class="form-select" onchange="change_filter();">
					<option value="0" selected="selected">All Chats</option>
					<option value="1">My Chats</option>
				</select>
			</div>
			<div class="col-md-3">
				<select id="jform_list_filter" name="jform[list_filter]" class="form-select" onchange="change_filter();">
					<option value="2">Title</option>
					<option value="9">Category</option>
					<option value="10">Owner</option>
				</select>
			</div>
			<div class="col-md-3">
				<select id="jform_list_asc" name="jform[list_asc]" class="form-select" onchange="change_filter();">
					<option value="0">Ascending</option>
					<option value="1">Descending</option>
				</select>
			</div>
			<div class="col-md-2">
				<select id="jform_list_limit" name="jform[list_limit]" class="form-select" onchange="change_filter();">
					<option value="10" selected="selected">10</option>
					<option value="15">15</option>
					<option value="20">20</option>
					<option value="25">25</option>
					<option value="30">30</option>
					<option value="50">50</option>
					<option value="100">100</option>
					<option value="200">200</option>
					<option value="500">500</option>
					<option value="0">All</option>
				</select>
			</div>
		</div>
	</div>
	
	<div class="taba-principal">
		<div id="showlist" name="flist"></div>
		<div id="pagination" class="pagination pagination-toolbar taba-pagination">
		</div>
	</div>

	<input type="hidden" name="jform[users_limit_global]" id="jform_users_limit_global" value="10">
	<input type="hidden" name="jform[username]" id="jform_username" value="<?php echo $currentuser->get("username"); ?>">
	<input type="hidden" name="jform[page_actual]" id="jform_page_actual" value="1">
	<input type="hidden" name="jform[tk]" id="jform_tk" value="<?php echo Session::getFormToken(); ?>">
	<input type="hidden" id="uri_tabapapo" value="<?php echo Uri::root(); ?>">
	<input type="hidden" id="taba_profile" value="<?php echo $profile; ?>">

</div>
<p style="text-align:right;" ><?php echo Text::_('COM_TABAPAPO_POWERED');?><a href="https://tabaoca.org">Tabaoca</a></p>

</form>
